/*
 * NOTICE OF LICENSE
 *
 * This file is licenced under the Software License Agreement.
 * With the purchase or the installation of the software in your application
 * you accept the licence agreement.
 *
 * You must not modify, adapt or create derivative works of this source code
 *
 *  @author    Toomas-Siim Teresk
 *  @copyright 2010-2015 Infovõrgud OÜ
 *  @license   LICENSE.txt
 */
// "use strict";
var SEBPAYMENTGATEWAY = {};
SEBPAYMENTGATEWAY.iframeVisible = 0;
SEBPAYMENTGATEWAY.managingCards = 0;
SEBPAYMENTGATEWAY.selectedBanklinkSource = undefined;
SEBPAYMENTGATEWAY.bankPaymentButtonAllowed = false; //task 17972
SEBPAYMENTGATEWAY.banklinkPaymentMethods = {
    'vp_placeholder': [],
    'EE': [],
    'LV': [],
    'LT': []
};

SEBPAYMENTGATEWAY.init = function(){
  SEBPAYMENTGATEWAY.changeCard();
};

SEBPAYMENTGATEWAY.setPaymentMethods = function() {
    //$("#banklinkPayButtonSEB").hide();  //Task 17972: we do not hide buttons on load anymore
    var iframe = $('#sebpaymentgatewayIframe');
    var bankLinksList = $(".sebpaymentgateway_banklinks_list");
    SEBPAYMENTGATEWAY.setLoadingIndicatorToBanklinks();
    $.ajax({
        url:iframe.attr("target-url")+"?fc=module&module=sebpaymentgateway&controller=accountinfo",
        dataType:"json",
        method:"GET",
        success:function(data) {

            //console.log('Account data acquisition success');
            //console.log(data);

            SEBPAYMENTGATEWAY.order_reference = data.order_reference;
            if (SEBPAYMENTGATEWAY.retryRedirect) {
                SEBPAYMENTGATEWAY.retryRedirect = SEBPAYMENTGATEWAY.retryRedirect.replace("ORDER_REFERENCE", data.order_reference);
            }
            // var countryCode = "EE";
            var paymentMethods = data["payment_methods"];
            for (var i = 0; i < paymentMethods.length; i++) {
                // bankLinksList seems to be reset by EVERYPAY.displayBankLinkPaymentMethods (called in processCountrySelectChange())
                // if (paymentMethods[i]["country_code"] === countryCode) bankLinksList.append(EVERYPAY.getBanklinkContainer(paymentMethods[i], "banklinkInput" + i));
                if (paymentMethods[i]["source"] === "card" || paymentMethods[i]["source"] === "paypal") {
                    SEBPAYMENTGATEWAY.paymentLinkToIframe(paymentMethods[i]["payment_link"], paymentMethods[i]["source"]);
                } else if (paymentMethods[i]["source"] !== "paypal") {
                    if ('undefined' !== typeof EVERYPAY.banklinkPaymentMethods[paymentMethods[i]['country_code']]) {
                        EVERYPAY.banklinkPaymentMethods[paymentMethods[i]['country_code']].push(paymentMethods[i]);
                    } else if (null === paymentMethods[i]['country_code'] || 'undefined' === typeof paymentMethods[i]['country_code']) {
                        // if country_code is null add to all countries
                        for(const [country, banksData] of Object.entries(EVERYPAY.banklinkPaymentMethods)) {
                            banksData.push(paymentMethods[i]);
                        }
                    }
                }

            }
            /*for (var method of paymentMethods) {
                if (method["country_code"] === countryCode) bankLinksList.append(SEBPAYMENTGATEWAY.getBanklinkContainer(method));
                if (method["source"] === "card") SEBPAYMENTGATEWAY.paymentLinkToIframe(method["payment_link"]);
            }*/
            SEBPAYMENTGATEWAY.removeEmptyBankLinkSelectCountryOptions();

            SEBPAYMENTGATEWAY.setSelectCountry(); // task 17971 - checks and sets selected drop down country as delivery address country

            SEBPAYMENTGATEWAY.removeLoadingIndicator();

            // SEBPAYMENTGATEWAY.updatePayButton('cardPayButtonSEB'); // task 17972 - makes pay by card button grayedout initially (iframe version)
            // SEBPAYMENTGATEWAY.updatePayButton('paypalPayButtonSEB'); // task 17972 - makes pay with paypal button grayedout initially (iframe version)
            SEBPAYMENTGATEWAY.updateBankPayButton('banklinkPayButtonSEB'); // task 17972 - makes pay by bank button grayedout initially

            SEBPAYMENTGATEWAY.processCountrySelectChange(); // displays links

            // task 17972
            SEBPAYMENTGATEWAY.attachRadioListeners();
            //var termsCheckbox = document.getElementById('conditions_to_approve[terms-and-conditions]');
            //attachlistenersSEB(termsCheckbox);
            var countrySelection = document.getElementById('sebpaymentgatewayBanklinkCountrySelect');
            attachlistenerSEB(countrySelection);

        },
        error:function(err) {

            //console.log('Account data acquisition error');
            //console.log(err);

            SEBPAYMENTGATEWAY.removeLoadingIndicator();
            var doc = iframe[0].contentWindow.document;
            var $body = $('body',doc);
            $body.html("<p>Cannot load payment page</p>");
            $body.css({"text-align": "center"});
            bankLinksList.append("<p>Cannot load banklinks</p>")
        }
    });
};

SEBPAYMENTGATEWAY.startPayment = function(source) {
    if (source !== "card" || source !== "paypal") {
        $("body").css("cursor", "progress");
    }
    var saveCardChecked = ($('.saveCardOption input[type="checkbox"]:checked').length !== 0 ? 1 : 0);
    var iframe = $('#sebpaymentgatewayIframe');
    let requestData = {
        saveCard:saveCardChecked,
	payment_method: source
    };
    if (source === 'card') requestData.card_choice = $('input[name="sebPaymentGatewayChoice"]:checked').val();
    $.ajax({
        url:iframe.attr("target-url")+"?fc=module&module=sebpaymentgateway&controller=validation&response_type=json",
        dataType:"json",
        data: requestData,
        method:"POST",
        success:function(data) {
            SEBPAYMENTGATEWAY.order_reference = data.order_reference;
            if (SEBPAYMENTGATEWAY.retryRedirect) {
                SEBPAYMENTGATEWAY.retryRedirect = SEBPAYMENTGATEWAY.retryRedirect.replace("ORDER_REFERENCE", data.order_reference);
            }
            if (source === "card" || source === 'paypal') {
                let paymentLink = undefined;
                if (typeof data.cc_details !== 'undefined') {
                    paymentLink = data.payment_link;
                } else {
                    paymentLink = SEBPAYMENTGATEWAY.getPaymentMethodInfo(source, data.payment_methods)["payment_link"];                }
                SEBPAYMENTGATEWAY.paymentLinkToIframe(paymentLink, source);

            } else {
                window.location = SEBPAYMENTGATEWAY.getPaymentMethodInfo(source, data.payment_methods)["payment_link"];

            }
        },
        error:function() {
            if (source === "card") {
                var doc = iframe[0].contentWindow.document;
                var $body = $('body', doc);
                $body.html("<p>Cannot get payment page</p>");
                $body.css({"text-align": "center"});
            }
            $("body").css("cursor", "default");
        }
    });
};

SEBPAYMENTGATEWAY.displayBankLinkPaymentMethods = function(countryCode) {
    let bankLinksList = $('.sebpaymentgateway_banklinks_list');
    let bankLinksData = SEBPAYMENTGATEWAY.banklinkPaymentMethods[countryCode];
    bankLinksList.empty();
    for (let i = 0; i < bankLinksData.length; i++) {
        bankLinksList.append(SEBPAYMENTGATEWAY.getBanklinkContainer(bankLinksData[i], "banklinkInput" + i));
    }
};

SEBPAYMENTGATEWAY.removeEmptyBankLinkSelectCountryOptions = function() {
    if(!($('#sebpaymentgatewayBanklinkCountrySelect').length)) {
        return;
    }
    $('#sebpaymentgatewayBanklinkCountrySelect > option').each(function() {
        if (!SEBPAYMENTGATEWAY.banklinkPaymentMethods[this.value].length) {
            this.remove();
        }
    });
};

// task 17971 sets selected country as cart delivery address country
SEBPAYMENTGATEWAY.setSelectCountry = function () {
    if(!($('#sebpaymentgatewayBanklinkCountrySelect').length)) {
        return;
    }
    var customerCountry = 'EE';
    if (sebpaymentgatewayCartAddressCountryISO === undefined || sebpaymentgatewayCartAddressCountryISO === null) {
        // pass
    } else {
        customerCountry = ( sebpaymentgatewayCartAddressCountryISO.length > 0 ? sebpaymentgatewayCartAddressCountryISO : 'EE');
    }
    $('#sebpaymentgatewayBanklinkCountrySelect > option').each(function () {
        if (this.value === customerCountry) {
            $('#sebpaymentgatewayBanklinkCountrySelect').val(this.value);
        }
    });
};

// task 17972
SEBPAYMENTGATEWAY.enableLinks = function () {
    if(!($('.js-payment-sebpaymentgateway').length)) {
        return;
    }
    $('.js-payment-sebpaymentgateway').each(function () {
        // todo possibly add conditions
        if (1 === 1/*this.value === customerCountry*/) {
            $(this).removeClass('disabled');
        }
    });
};

// task 17972 - this restores payment options visibility after they being hidden by PS if terms checkbox is not checked atm
SEBPAYMENTGATEWAY.attachRadioListeners = function () {
    var sebpaymentgatewayRadioOptions = document.getElementsByName("payment-option");
    sebpaymentgatewayRadioOptions.forEach((option) => {
        if (option.getAttribute('data-module-name') === 'sebpaymentgateway') {
            option.addEventListener("change", async function () {
                    await SEBPAYMENTGATEWAY.sleep(100);
                    SEBPAYMENTGATEWAY.enableLinks();
                }
                , false);
        }
    });
};

// task 17972 // this is used to attach listeners to terms checkbox to make banklinks visible on terms status change and to change pay button style
function attachlistenersSEB(element) {
    element.addEventListener("change", async function() {
        await SEBPAYMENTGATEWAY.sleep(100);
        SEBPAYMENTGATEWAY.enableLinks();}
    );

    let button1 = document.getElementById('cardPayButtonSEB');
    if (button1) {
        element.addEventListener("change", function() {
            SEBPAYMENTGATEWAY.updatePayButton('cardPayButtonSEB');} // pay by card button
        );
    }

    let button2 = document.getElementById('paypalPayButtonSEB');
    if (button2) {
        element.addEventListener("change", function() {
            SEBPAYMENTGATEWAY.updatePayButton('paypalPayButtonSEB');} // pay with paypal button
        );
    }

    let button3 = document.getElementById('banklinkPayButtonSEB');
    if (button3) {
        element.addEventListener("change", function() {
            SEBPAYMENTGATEWAY.updateBankPayButton('banklinkPayButtonSEB');} // pay by bank button
        );
    }
}

// task 17972 //used to attach pay btn status updating to bank payment country selector and to reset saved payment source
function attachlistenerSEB(element) {
    if (!element ) {
        return;
    }
    element.addEventListener("change", function() {
        SEBPAYMENTGATEWAY.updateBankPayButton('banklinkPayButtonSEB');} // pay by bank button status update
    );
    element.addEventListener("change", function() {
        SEBPAYMENTGATEWAY.changeSelectedBanklinkSource(undefined);} // this resets saved payment source on country change
    );
}

// task 17972
SEBPAYMENTGATEWAY.sleep = function (ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
};

// task 17972
// in PS 16 terms must be accepted before payment options screen is displayed, so no need to check additionally
SEBPAYMENTGATEWAY.areTermsAccepted = function () {
    return true;
};

/*SEBPAYMENTGATEWAY.areTermsAccepted = function () {
    let checkBoxStatus = document.getElementById('conditions_to_approve[terms-and-conditions]');
    if (!checkBoxStatus) {
        return false;
    } else {
        return checkBoxStatus.checked;
    }
};*/

//task 17972 // works with iframe version of card and paypal payment buttons
SEBPAYMENTGATEWAY.updatePayButton = function (id) {
    if (!id) {
        return;
    }
    let button = document.getElementById(id);
    if (!button) {
        return;
    }
    let checkboxes = document.getElementsByClassName("sebCheckBoxPay"); // this has universal name for both card and paypal iframe payments

    let terms = SEBPAYMENTGATEWAY.areTermsAccepted();
    if (!terms) {
        button.classList.add('grayedout');
        if (checkboxes.length > 0) {
            for (let index = 0; index < checkboxes.length; index++) {
                checkboxes[index].disabled = true;
            }
        }
    } else {
        button.classList.remove('grayedout');
        if (checkboxes.length > 0) {
            for (let index = 0; index < checkboxes.length; index++) {
                checkboxes[index].disabled = false;
            }
        }
    }
};
//task 17972 // works with banklinkpayment button
SEBPAYMENTGATEWAY.updateBankPayButton = function (id) {
    if (!id) {
        return;
    }
    let button = document.getElementById(id);
    if (!button ) {
         return;
    }
    let terms = SEBPAYMENTGATEWAY.areTermsAccepted();
    let radioSelected = ($('input[name=banklinkChoiceSEB]:checked').length > 0);
    if (!terms || !radioSelected ) {
        SEBPAYMENTGATEWAY.bankPaymentButtonAllowed = false;
        button.classList.add('grayedout');
    } else {
        SEBPAYMENTGATEWAY.bankPaymentButtonAllowed = true;
        button.classList.remove('grayedout')
    }
};


SEBPAYMENTGATEWAY.processCountrySelectChange = function() {
    if(!($('#sebpaymentgatewayBanklinkCountrySelect').length)) {
        return;
    }
    let selectedCountry = $('#sebpaymentgatewayBanklinkCountrySelect').val();
    // if (null == selectedCountry ) {
    //     return false;
    // }
    SEBPAYMENTGATEWAY.displayBankLinkPaymentMethods(selectedCountry);
};

SEBPAYMENTGATEWAY.open = function(paymentMethod){

    SEBPAYMENTGATEWAY.startPayment(paymentMethod);

    // disabled hiding of other module payment options
   /*$('.row').each(function(){
      if ($(this).find('.payment_module').length >= 1 && !$(this).find('.payment_module').hasClass('sebpaymentgateway')) $(this).hide(2000);
   });*/


//    $('.sebpaymentgatewayRedirect.button').hide();

   /*var choice = $('input[name="sebpaymentgatewayChoice"]:checked');
   if (choice.length == 0 || $(choice).val() == "new")
   {
         SEBPAYMENTGATEWAY.openIframe();
   }
   else
   {
         SEBPAYMENTGATEWAY.closeIframe();
   }*/
    SEBPAYMENTGATEWAY.openIframe(paymentMethod);

//MANAGE CARDS START
   /*var saveCardChecked = ($('.saveCardOption input[type="checkbox"]:checked').length !== 0 ? 1 : 0);
   var iframe = $('#sebpaymentgatewayIframe');
   $.ajax({
      url:iframe.attr("target-url")+"?fc=module&module=sebpaymentgateway&controller=validation&response_type=json",
      dataType:"json",
      data:{card_choice:$('input[name="sebpaymentgatewayChoice"]:checked').val(), saveCard:saveCardChecked},
      method:"POST",
      success:function(data) {
            SEBPAYMENTGATEWAY.order_reference = data.order_reference;
            SEBPAYMENTGATEWAY.retryRedirect = SEBPAYMENTGATEWAY.retryRedirect.replace("ORDER_REFERENCE", data.order_reference);
            SEBPAYMENTGATEWAY.paymentLinkToIframe(SEBPAYMENTGATEWAY.getPaymentMethodInfo("card", data.payment_methods)["payment_link"]);
      },
       error:function() {
           var doc = iframe[0].contentWindow.document;
           var $body = $('body',doc);
           $body.html("<p>Cannot get payment page</p>");
           $body.css({"text-align": "center"});
       }
   });*/
};

SEBPAYMENTGATEWAY.getPaymentMethodInfo = function(source, payment_methods) {
    for (var i = 0; i < payment_methods.length; i++) {
        if (payment_methods[i].source === source) return payment_methods[i];
    }
};

SEBPAYMENTGATEWAY.paymentLinkPageToIframe = function(paymentLink) {
    if ($('#sebpaymentgatewayForm').length > 0) $('#sebpaymentgatewayForm').remove();
    $('#sebpaymentgatewayIframe').parent().append('<form method="post" action="'+paymentLink+'" id="sebpaymentgatewayForm"></form>');
    $('#sebpaymentgatewayForm').attr("target", "SEBPAYMENTGATEWAYIFRAME");
    $('#sebpaymentgatewayForm').submit();
};

SEBPAYMENTGATEWAY.paymentLinkToIframe = function(paymentLink, paymentMethod) {
    var $iframe = $("#" + paymentMethod + "-iframe" + "-SEB");
    $iframe.attr("src", paymentLink);
};

SEBPAYMENTGATEWAY.deleteCard = function(obj){
   if (confirm(sebpaymentgateway_delete_txt)) {
      var link = $(obj).attr('data-remove-card-link');
      $.ajax({
      url:link,
      success:$(obj).parent().remove()
      }).done(function(){
        $('#checkout-payment-step').addClass('-current js-current-step');
        if($('.sebpaymentgatewayOption').length < 1){
         $('.sebpaymentgatewayChoices').find('.sebpaymentgatewayManagecards').addClass('hidden');
        }
      });
   }
};

SEBPAYMENTGATEWAY.setDefault = function(obj){
   var link = $(obj).attr('data-set-default-link');
   $.ajax({
         url:link
      });
   $(obj).parent().find('.makeDefault').removeClass('manageCardUI').hide();
   $('.sebpaymentgatewayOption.default').removeClass('default').find('.makeDefault').addClass('manageCardUI').show();
   $(obj).parent().addClass('default');
};

SEBPAYMENTGATEWAY.changeCard = function(){
   if ($('input[name="sebpaymentgatewayChoice"][value="new"]:checked').length !== 0){
      $('.saveCardOption').show();
   }else{
      $('.saveCardOption').hide();
   }
};

SEBPAYMENTGATEWAY.manageCardsToggle = function(){
   if (SEBPAYMENTGATEWAY.managingCards){
      $('.manageCardUI').hide();
      SEBPAYMENTGATEWAY.managingCards = 0;
   }else{
      $('.manageCardUI').show();
      SEBPAYMENTGATEWAY.managingCards = 1;
   }
};
//MANAGE CARDS END

SEBPAYMENTGATEWAY.closeIframe = function(){
   SEBPAYMENTGATEWAY.iframeVisible = 0;
   $( ".sebpaymentgatewayIframe" ).show().removeClass('visible').animate({
                  height: "0px"
               }, 500);
   //$('.sebpaymentgatewayUI').show();
   $('.payment_module.sebpaymentgateway').attr('style', '');
   $('.payment_module.sebpaymentgateway').removeClass('iframe_opened');

};

SEBPAYMENTGATEWAY.openIframe = function(paymentMethod){
    SEBPAYMENTGATEWAY.closeIframe();
    var paymentModuleContainerSelector = "." + paymentMethod + "-payment-container";
    $(paymentModuleContainerSelector).addClass('iframe_opened');
    $(paymentModuleContainerSelector).css('width', '358px');
    $(paymentModuleContainerSelector).css('height', '510px');
    $( "#" + paymentMethod + "-iframe" + "-SEB" ).show().addClass('visible').animate({
        width: "358px",
                  height: "900px"
               }, 500);
    $('#sebpaymentgateway_card_option').removeClass('card_details_shown');
    $('#sebpaymentgateway_card_option').addClass('card_details_hidden');
   //$(paymentModuleContainerSelector + ' .sebpaymentgatewayUI').hide();
   SEBPAYMENTGATEWAY.setLoadingIndicatorToIframe(paymentMethod);
   SEBPAYMENTGATEWAY.iframeVisible = 1;
};

SEBPAYMENTGATEWAY.setLoadingIndicatorToIframe = function(paymentMethod) {
    var $iframe = $('#' + paymentMethod + '-iframe' + '-SEB');
    var doc = $iframe[0].contentWindow.document;
    var $body = $('body',doc);
    $body.html('<img class="loadingIndicator" src="' + baseUri + '/modules/sebpaymentgateway/views/img/loader.gif"/>');
    $body.css({"text-align": "center"});
};

SEBPAYMENTGATEWAY.setLoadingIndicatorToBanklinks = function() {
    $(".sebpaymentgateway_banklinks_list").append('<img class="loadingIndicator" src="' + baseUri + '/modules/sebpaymentgateway/views/img/loader.gif"/>')
};

SEBPAYMENTGATEWAY.removeLoadingIndicator = function() {
    $(".loadingIndicator").remove();
};

SEBPAYMENTGATEWAY.reclose = function(){
   if ($('#sebpaymentgatewayIframe').attr('order-create-method') != "after")
   {
      window.location=SEBPAYMENTGATEWAY.retryRedirect;
   }
   else
   {
      $('#sebpaymentgatewayRetryButton').hide();
      $('.row').each(function(){
            if ($(this).find('.payment_module').length >= 1 && !$(this).find('.payment_module').hasClass('sebpaymentgateway')) $(this).show(2000);
         });
       SEBPAYMENTGATEWAY.closeIframe();
       setTimeout("$('.sebpaymentgatewayRedirect.button').show();", 2000);
   }
};

SEBPAYMENTGATEWAY.createQuery = function(data){
      if ($('#sebpaymentgatewayForm').length > 0) $('#sebpaymentgatewayForm').remove();
      $('#sebpaymentgatewayIframe').parent().append('<form method="post" action="'+data.sebpaymentgateway_url+'" id="sebpaymentgatewayForm"></form>');
      var i = 0;
      while (i < data.data.length)
      {
        $('#sebpaymentgatewayForm').append("<input type='hidden' name='"+data.data[i].key+"' value='"+data.data[i].value+"'>");
        i++;
      }
      $('#sebpaymentgatewayForm').attr("target", "SEBPAYMENTGATEWAYIFRAME");
      $('#sebpaymentgatewayForm').submit();
    };


SEBPAYMENTGATEWAY.getBanklinkContainer = function(data, inputId) {
    //return "<div onclick='SEBPAYMENTGATEWAY.startPayment(\""+data.source+"\")' class='sebpaymentgateway_banklink_container'><img src='"+data.logo_url+"' alt='"+data.display_name+"' /></div>";
    return "" +
        "<div class='sebpaymentgateway_banklink_container'>" +
        "<input id='"+inputId+"' name='banklinkChoiceSEB' type='radio' onclick='SEBPAYMENTGATEWAY.showBankLinkPayButton(); SEBPAYMENTGATEWAY.updateBankPayButton(\"banklinkPayButtonSEB\"); SEBPAYMENTGATEWAY.changeSelectedBanklinkSource(\""+data.source+"\")'/>" +
        "<label for='"+inputId+"' class='banklink_input_label'>" +
        "<img src='"+data.logo_url+"' alt='"+data.display_name+"'/>" +
        "</label>" +
        "</div>";
};

SEBPAYMENTGATEWAY.showBankLinkPayButton = function () {
    $("#banklinkPayButtonSEB").show();
};

SEBPAYMENTGATEWAY.changeSelectedBanklinkSource = function(source) {
    this.selectedBanklinkSource = source;
};

// added checking for disabled condition in task 17972
SEBPAYMENTGATEWAY.startBanklinkPayment = function() {
    if (!SEBPAYMENTGATEWAY.bankPaymentButtonAllowed) {
        return;
    }
    SEBPAYMENTGATEWAY.startPayment(this.selectedBanklinkSource);
};

SEBPAYMENTGATEWAY.isApplePayAvailable = function () {
    $.ajax({
        url: "/?fc=module&module=sebpaymentgateway&controller=accountinfo",
        dataType: "json",
        method: "GET",
        success: function (data) {
            let card = false;
            let paymentMethods = data["payment_methods"];
            for (let i = 0; i < paymentMethods.length; i++) {
                if (paymentMethods[i]["source"] !== "card") {
                    continue;
                }
                card = true;
                if (true !== paymentMethods[i]["applepay_custom_available"]) {
                    document.getElementById('apple_pay_form').remove();
                    break;
                }
                if (window.ApplePaySession && ApplePaySession.canMakePayments()) {
                    let applePayForm = document.getElementById('apple_pay_form');
                    applePayForm.style.display = 'block';
                    if (!applePayForm.onclick) {
                        applePayForm.addEventListener('click', async function () {
                            await SEBPAYMENTGATEWAY.applePayChangeCursor();
                            setTimeout(function() {
                                SEBPAYMENTGATEWAY.applePayClick();
                            }, 500);
                        });
                    }
                } else {
                    document.getElementById('apple_pay_form').remove();
                }
            }
            if (false === card) {
                document.getElementById('apple_pay_form').remove();
            }
        },
        error: function () {
            document.getElementById('apple_pay_form').remove();
        }
    });
};

SEBPAYMENTGATEWAY.applePayChangeCursor = async function () {
    let applePayButton = document.getElementById('apple-pay-button');
    let applePayForm = document.getElementById('apple_pay_form');
    document.body.style.cursor = 'progress';
    applePayButton.parentElement.style.cursor = 'progress';
    applePayForm.disabled = true;
};

SEBPAYMENTGATEWAY.applePayClick = function () {
    let applePayButton = document.getElementById('apple-pay-button');
    let applePayForm = document.getElementById('apple_pay_form');
    if (!SEBPAYMENTGATEWAY.areTermsAccepted()) {
        document.body.style.cursor = 'auto';
        applePayButton.parentElement.style.cursor = 'pointer';
        applePayForm.disabled = false;
        return;
    }
    let requestData = {
        payment_method: 'apple_pay'
    };

    try {
        let oneoff = $.ajax({
            url: "/?fc=module&module=sebpaymentgateway&controller=validation&response_type=json",
            dataType: "json",
            data: requestData,
            method: "POST",
            async: false,
        });
        SEBPAYMENTGATEWAY.startApplePaySession(oneoff.responseJSON);
    } catch (error) {
        document.body.style.cursor = 'auto';
        applePayButton.parentElement.style.cursor = 'pointer';
        applePayForm.disabled = false;
        return;
    }

    setTimeout(function() {
        document.body.style.cursor = 'auto';
        applePayButton.parentElement.style.cursor = 'pointer';
        applePayForm.disabled = false;
    }, 2000);
};

SEBPAYMENTGATEWAY.startApplePaySession = function (oneoff) {
    if (window.ApplePaySession && ApplePaySession.canMakePayments()) {
        let store_name = document.getElementById('store-name').value;
        let applePayClient = ApplePayClient.initialize({
            access_token: oneoff.mobile_access_token,
            api_username: oneoff.api_username,
            merchant_id:  oneoff.applepay_merchant_identifier,
            account_name: oneoff.account_name,
        });
        applePayClient.createApplePayPayment({
            payment_reference: oneoff.payment_reference,
            country_code: oneoff.descriptor_country,
            currency_code: oneoff.currency,
            payment_link: oneoff.payment_link,
            total: {
                label: store_name,
                amount: oneoff.initial_amount,
            }
        });
    } else {
        return;
    }
};

var shrinkIframe = function(iframe, iframe_data) {
   iframe.css(iframe_data);
   jQuery("#dimmed_background_box").remove();
};
var expandIframe = function() {
   var iframe_data = {
      position: iframe.attr("position") || "static",
      top: iframe.position().top,
      left: iframe.position().left,
      width: iframe.width(),
      height: iframe.height(),
      zIndex: iframe.attr("zIndex"),
      marginLeft: iframe.attr("marginLeft"),
      marginRight: iframe.attr("marginRight")
   };

   jQuery('body').append("<div id='dimmed_background_box'></div>");
   jQuery('#dimmed_background_box').css({ height:'100%',width:'100%',position:'fixed',top:0,left:0,zIndex:9998,backgroundColor:'#000000',opacity:0.5 });

   var window_height = jQuery(window).height();
   var window_width = jQuery(window).width();

   if (window_width < 960) {
      iframe.css({ height:window_height,width:window_width,top:0 });
   } else {
      iframe.css({ height:640,width:960,top:(window_height-640)/2 });
   }
   iframe.css({ position:'fixed',zIndex:9999,margin:'auto' });
   return iframe_data;
};

var shrinked_iframe_data;
//var iframe = $('#sebpaymentgatewayIframe'); // iframe selector should be used

window.addEventListener('message', function(event) {
   var message = JSON.parse(event.data);
   /*
   1. An "expand" message is sent from the iframe page when 3D secure page is going to be displayed.
       The size of the iframe should be adjusted to hold 3D secure page
   2. A "shrink" message is sent from the iframe page when a user has provided authorisation details on the 3D secure page.
       The size of the iframe should be set to the initial values
   */
   if (message.resize_iframe == "expand") {
      shrinked_iframe_data = expandIframe(iframe);
   } else if (message.resize_iframe == "shrink") {
      shrinkIframe(iframe, shrinked_iframe_data);
   }

   if (message.transaction_result){
         if (message.transaction_result == "completed")
         {
            window.location=$('#sebpaymentgatewayIframe').attr("target-url")+"?fc=module&module=sebpaymentgateway&controller=return&order_reference="+SEBPAYMENTGATEWAY.order_reference+"&transaction_result="+message.transaction_result;
         }
         else
         {
            if (SEBPAYMENTGATEWAY.iframeVisible)
            {
               $('#sebpaymentgatewayRetryButton').show();
            }
            else
            {
               SEBPAYMENTGATEWAY.openIframe();
               $('#sebpaymentgatewayRetryButton').show();
            }
         }
   }
}, false);

function var_dump(obj, alert) {
      var out = '';
      for (var i in obj) {
            out += i + ": " + obj[i] + "\n";
      }
      if (alert) alert(out);
      return out;
}

/* 
    Custom JS code
*/


// Set listener to show / hide bank links content 
document.querySelector('body').addEventListener("click", function(e) {
    var paymentMethodContainer = document.querySelector('#iframe_payment .payment_module.sebpaymentgateway.seb_banklink');
    // For some reason clicking title doesnt trigger click event so we add additional check for it
    var paymentMethodTitle = document.querySelector('#iframe_payment .payment_module.sebpaymentgateway .payment_title');

    /*if (!paymentMethodContainer) {
        return;
    }*/
    if (paymentMethodContainer) {
        if (e.target == paymentMethodContainer || e.target == paymentMethodTitle) {
            paymentMethodContainer.classList.add('details_shown');
            paymentMethodContainer.classList.remove('details_hidden');
            SEBPAYMENTGATEWAY.closeIframe();

            /*$('.row').each(function(){
                if ($(this).find('.payment_module').length >= 1 && !$(this).find('.payment_module').hasClass('sebpaymentgateway')) $(this).show(1000);
            });*/

        } else {
            paymentMethodContainer.classList.add('details_hidden');
            paymentMethodContainer.classList.remove('details_shown');
        }
    }

    // this part needs development. goal is to close open iframe if clicked on empty field
    /*var cardPaymentContainer = document.querySelector('#iframe_payment .payment_module.sebpaymentgateway.card-payment-container');
    var paypalPaymentContainer = document.querySelector('.payment_module.sebpaymentgateway.paypal-payment-container');
    if (true/!*cardPaymentContainer*!/) {
        if (e.target != cardPaymentContainer || e.target != paypalPaymentContainer || e.target != paymentMethodContainer) {
            SEBPAYMENTGATEWAY.closeIframe();
        }
    }*/

});

// Set additional event listener to prevent payment content from closing if child elements were clicked
try {
    document.querySelector('#iframe_payment .payment_module.sebpaymentgateway.seb_banklink').addEventListener("click", function(e) {
        var paymentMethodContainer = document.querySelector('#iframe_payment .payment_module.sebpaymentgateway.seb_banklink');

        if (paymentMethodContainer.classList.contains('details_shown')) {
            e.stopPropagation();
        }
    });
} catch (err) { }



// Set listener to show / hide card payment option content
document.querySelector('body').addEventListener("click", function(e) {
    var paymentMethodContainer = document.querySelector('#sebpaymentgateway_card_option.payment_module.sebpaymentgateway');
    // For some reason clicking title doesnt trigger click event so we add additional check for it
    var paymentMethodTitle = document.querySelector('#sebpaymentgateway_card_option.payment_module.sebpaymentgateway .payment_title');

    /*if (!paymentMethodContainer) {
        return;
    }*/
    if (paymentMethodContainer) {
        if (e.target == paymentMethodContainer || e.target == paymentMethodTitle) {
            paymentMethodContainer.classList.add('card_details_shown');
            paymentMethodContainer.classList.remove('card_details_hidden');
            SEBPAYMENTGATEWAY.closeIframe();

            /*$('.row').each(function(){
                if ($(this).find('.payment_module').length >= 1 && !$(this).find('.payment_module').hasClass('sebpaymentgateway')) $(this).show(1000);
            });*/

        } else {
            paymentMethodContainer.classList.add('card_details_hidden');
            paymentMethodContainer.classList.remove('card_details_shown');
        }
    }

});

// Set additional event listener to prevent payment content from closing if child elements were clicked
try {
    document.querySelector('#sebpaymentgateway_card_option.payment_module.sebpaymentgateway').addEventListener("click", function(e) {
        var paymentMethodContainer = document.querySelector('#sebpaymentgateway_card_option.payment_module.sebpaymentgateway');

        if (paymentMethodContainer.classList.contains('card_details_shown')) {
            e.stopPropagation();
        }
    });
} catch (err) { }