{*
* NOTICE OF LICENSE
*
* This source file is subject to the Open Software License (OSL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/osl-3.0.php
*
*  @author    Veebipoed.ee, SEB Payment Gateway
*  @copyright 2015 Veebipoed.ee, SEB Paymant Gateway
*  @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
*}
<form id="payment-form" action="{$payment_link}" method="GET">
	<div class="row">
		<div class="col-xs-12">
			<div id="sebpaymentgateway_card_option" class="payment_module sebpaymentgateway card_details_hidden">
				<div class="sebpaymentgateway_card_logo"></div>
				<div class="payment_title">{l s='Pay by Card' mod='sebpaymentgateway'}</div>
				<span class="sebpaymentgatewayChoices">
					{if !$logged && $token_payment == 1}
						<span class="sebpaymentgatewayNotification">
							To save your card securely for faster payments in the future, <a href="{$link->getPageLink('authentication', true)}?create_account=1" class="pay-login-links">register</a> for an account or <a href="{$link->getPageLink('authentication', true)}" class="pay-login-links">log in</a> to your existing account.
						</span>
					{else}
						<div style="display:none;"></div>
					{/if}

					{if $logged && $token_payment == 1}
						<span id="sebpaymentgatewayChoice">
							{foreach from=$cards item=card}
								<div class="sebpaymentgatewayOption {if $card->is_default}default{/if}">
										<img class="cardimg" src="{$this_path}views/img/sebpaymentgateway_{$card->card_type}.png" alt="{ucfirst($card->card_type)}">
										<span>
											<input onclick='SEBPAYMENTGATEWAY.changeCard()' type="radio" {if $card->is_default}checked="checked"{/if} name="sebPaymentGatewayChoice" value="{$card->id_card}" />
										</span>
										<label>
											**** **** **** {sprintf("%04d", $card->card_no)} ({l s='Expires' mod='sebpaymentgateway'} {sprintf("%02d", $card->card_exp_month)}/{sprintf("%02d", $card->card_exp_year)})
										</label>
										<a data-remove-card-link="{$link->getModuleLink('sebpaymentgateway', 'mycards', ['id_card'=>$card->id_card, 'action'=>'delete', 'ajax'=>1], true)}" onclick='SEBPAYMENTGATEWAY.deleteCard(this)' style="display:none;" class="manageCardUI" title="{l s='Delete' mod='sebpaymentgateway'}">{l s='Delete' mod='sebpaymentgateway'}</a>
										
										<a data-set-default-link="{$link->getModuleLink('sebpaymentgateway', 'mycards', ['id_card'=>$card->id_card, 'action'=>'default', 'ajax'=>1], true)}" onclick='SEBPAYMENTGATEWAY.setDefault(this)' style="display:none;" class="makeDefault {if !$card->is_default}manageCardUI{/if}">{l s='Make default' mod='sebpaymentgateway'}</a>
								</div>
							{/foreach}
							<div class="newCardOption">
							<img class="cardimg" src="{$this_path}views/img/credit-card-small.png" alt="New Card">
							<span class="use_new_mar use_new_mt">
								<input id="use_new_card" type="radio" name="sebPaymentGatewayChoice" {if count($cards)==0}checked{/if} onclick='SEBPAYMENTGATEWAY.changeCard()' value="new" />
								<label for="use_new_card">{l s='Use a new card' mod='sebpaymentgateway'}</label>
							</span>
							<br/>
							</div>
							<!--<span class="saveCardOption use_new_mar">
								<input id="save_new_card" type="checkbox" name="sebpaymentgatewaySaveCard" value="1" />
								<label for="save_new_card">{l s='Save card securely' mod='sebpaymentgateway'}</label>
							</span>-->
						</span>
						{if empty($cards)}
							<span class="sebpaymentgatewayManagecards sebpaymentgatewayUI" style="display:none;">No cards added</span>
						{else}
							<span class="sebpaymentgatewayManagecards sebpaymentgatewayUI" onclick="SEBPAYMENTGATEWAY.manageCardsToggle()">{l s='Manage cards' mod='sebpaymentgateway'}</span>
						{/if}
					{/if}
					<button type='submit' class='button sebpaymentgatewayRedirect'>Pay</button>
				</span>

			</div>
			<div class="clearfix"></div>
		</div>
	</div>
    <input type="hidden" name="payment_method" value="card"/>
</form>
{*<script type="text/javascript" src="/js/jquery/jquery-1.11.0.min.js"></script>*}
<script src="{$this_path}views/js/sebpaymentgateway.js"></script>
{*<script type="text/javascript" src="https://code.jquery.com/jquery-1.11.0.min.js"></script>*}
{*<script type="text/javascript" src="/js/jquery/jquery-migrate-1.2.1.min.js"></script>*}
<script>
	var sebpaymentgateway_delete_txt = "{l s='Are you sure you want to delete the card ?' mod='sebpaymentgateway'}";
	SEBPAYMENTGATEWAY.changeCard();
</script>
